/*  Time-stamp: <2005-05-27 17:06:36 >  */
#include  "4ru.h"
#include  <glut.h>
#include  "GLcolors.h"


extern int win_w;
extern int win_h;


extern NOTE_NODE *note_top;
extern NOTE_NODE *note_bot;
/* extern NOTE_NODE *note_cur; */
extern NOTE_NODE *note_alc;
extern NOTE_NODE *view_note_bot;

extern int gpr_view;
extern double draw_on_time_bias;
extern char gttm_line[STR_LEN];
extern char arg_file[STR_LEN];

extern int gttm_exec;
extern GARC *gtop;


int draw_NOTElist(NOTE_HEADER note_header_info, NOTE_NODE *view_note_cur, double Lbot, double Ltop, double inter,
		  double Velbot, double Veltop, double BTbot, double BTtop, int BTl, int BTh,
		  double damper_bot, double damper_top,
		  double ppqbeat, double alpha, DRUM_DEF *drum_data)
{
  NOTE_NODE *cur;
  NOTE_NODE *same;
/*   NOTE_NODE *srch; */
  int retstat;
  static GLdouble event_colors[8][4];
  static GLdouble damper_colors[4];
  static GLdouble BT_colors[4];
  static GLdouble bound_colors[4];
  double damper_x;
  double damper_y;
  double pre_damper_x;
  double pre_damper_y;

  double beattime;
  double BT_x;
  double BT_y;
  double pre_BT_x;
  double pre_BT_y;
  char str_tmp[STR_LEN];
  double BAR_x;
  double bound_x;

  int i;



  note_header_info = note_header_info;

/*   draw_line(0, 100, win_w, 100, 2, 1.0, 1.0, 1.0); */

  retstat = EXIT_SUCCESS;
  damper_x = 0;
  damper_y = damper_top;
  pre_damper_x = 0;
  pre_damper_y = damper_top;
  BT_x = 0;
  BT_y = BTbot;
  pre_BT_x = 0;
  pre_BT_y = BTbot;
  if(note_header_info.beattime != -1){
    beattime = note_header_info.beattime * 16.0 / note_header_info.beattime_base;
    BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
    pre_BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
  }


  if(note_header_info.bpm != -1){
    beattime = 60000.0 / (note_header_info.bpm * note_header_info.bpm_base / 16.0);
    BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
    pre_BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
  }


  for(i = 0; i < 4; i++){
    damper_colors[i] = OpenGLcolors[3][i];
    damper_colors[A] = alpha;
    BT_colors[i] = OpenGLcolors[4][i];
    BT_colors[A] = alpha;
    bound_colors[i] = OpenGLcolors[6][i];
    bound_colors[A] = alpha;
  }
/*   BT_colors[0] = 0.4; */
  BT_colors[1] *= 0.9;
  BT_colors[2] = 0.4;

  bound_colors[1] *= 0.9;
  bound_colors[2] *= 0.9;

/*   bound_colors[0] = 255; */
/*   bound_colors[1] = 215;  */
/*   bound_colors[2] = 0;  */

  cur = view_note_cur;
  draw_on_time_bias = cur->on_time.beat * ppqbeat - 100;
/*   printf("bias: %f\n", draw_on_time_bias); */
  while(cur != NULL){
/*     if(note_cur == note_top){   break;  } */
    same = cur;
    while(same != NULL){
      switch(same->ident){
      case  NOTE:
/* 	glLoadName(eventid++); */
	set_event_colors(same->str[1], event_colors);
	retstat = draw_event(same, Lbot, inter, Velbot, Veltop, ppqbeat, alpha, draw_on_time_bias, event_colors, drum_data);
	if(gttm_exec == ON){
	  draw_GTTM_value(same, ppqbeat, draw_on_time_bias, Ltop);
	}
/* 	printf("GPR3a: %5.3f\n", same->GPR[3]); */

	break;

      case  DAMPER:
/* 	printf("Damper %5.2f\n", Damper_val); */

	damper_x = (same->on_time.beat * ppqbeat) - draw_on_time_bias;
	draw_H_line(pre_damper_x, pre_damper_y, damper_x, pre_damper_y, damper_colors, 2);

/* 	damper_y = ((damper_top - damper_bot) / 128) * same->val[0] + damper_bot; */
	damper_y = (damper_top - damper_bot) - (((damper_top - damper_bot) / 128) * same->val[0]) + damper_bot;

	draw_V_line(damper_x, pre_damper_y, damper_x, damper_y, damper_colors, 2);
	sprintf(str_tmp, "%d", (int)same->val[0]);
	put_str_small(damper_x, damper_y + 4, 0, OpenGLcolors[3], str_tmp);

	pre_damper_x = damper_x;
	pre_damper_y = damper_y;

	break;


      case  BEATTIME:
	beattime = same->val[0] * 16.0 / same->val[1];

	BT_x = (same->on_time.beat * ppqbeat) - draw_on_time_bias;
	draw_H_line(pre_BT_x, pre_BT_y, BT_x, pre_BT_y, BT_colors, 2);
	BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
	draw_V_line(BT_x, pre_BT_y, BT_x, BT_y, BT_colors, 2);
	sprintf(str_tmp, "%5.1f (%5.1f)", beattime, 60000.0 / beattime);
	put_str_small(BT_x, BT_y + 4, 0, BT_colors, str_tmp);

	pre_BT_x = BT_x;
	pre_BT_y = BT_y;

	break;


      case  BPM:
	beattime = 60000.0 / (same->val[0] * same->val[1] / 16.0);

	BT_x = (same->on_time.beat * ppqbeat) - draw_on_time_bias;
	draw_H_line(pre_BT_x, pre_BT_y, BT_x, pre_BT_y, BT_colors, 2);
	BT_y = BTtop - (BTtop - BTbot) / (BTh - BTl) * (beattime - BTl);
	draw_V_line(BT_x, pre_BT_y, BT_x, BT_y, BT_colors, 2);
	sprintf(str_tmp, "%5.1f (%5.1f)", beattime, 60000.0 / beattime);
	put_str_small(BT_x, BT_y + 4, 0, BT_colors, str_tmp);

	pre_BT_x = BT_x;
	pre_BT_y = BT_y;

	break;


      case  BAR:
	if(cur->next != NULL){
	  if(cur->on_time.beat != cur->next->on_time.beat){
	    BAR_x = (cur->on_time.beat * ppqbeat) - draw_on_time_bias;
	  }else{
	    BAR_x = (cur->on_time.beat * ppqbeat) - draw_on_time_bias;
	  }
	}else{
	  BAR_x = ((cur->on_time.beat + 1.0) * ppqbeat) - draw_on_time_bias;
	}
	draw_V_line(BAR_x, Lbot, BAR_x, Ltop, OpenGLcolors[0], 1);
	sprintf(str_tmp, "%d", (int)same->val[0]);
	put_str(BAR_x, Ltop + 4, 0, OpenGLcolors[0], str_tmp);

	break;


      case  MEMO:
	if(same->str[0][0] == '/'){  /*  Boundary  */
	  if((cur->next != NULL) && (cur->pre != NULL)){
	    bound_x = ( ( (
		       (cur->next->on_time.beat + cur->next->on_diff.beat) +
		       (cur->pre->on_time.beat + cur->pre->on_diff.beat + cur->pre->len.beat + cur->pre->len_diff.beat)
		       ) / 2.0) * ppqbeat) - draw_on_time_bias;

#define GTTMVALUE
#ifdef  GTTMVALUE
	    disp_gttm_value(Henle, arg_file, cur, gttm_line);
#endif

	  }else{
	    bound_x = ((same->on_time.beat - 0.05) * ppqbeat) - draw_on_time_bias;
	  }
	  draw_V_line(bound_x, 0, bound_x, Ltop + 50, bound_colors, 4);
	  sprintf(str_tmp, "%2.1f", same->val[0]);
	  put_str_large(bound_x, Ltop + 4 + 50, 0, bound_colors, str_tmp);
	}
	break;

      default:
	break;
      }

      if(retstat >= (win_w + 100)){
	goto topexit;
      }

      same = same->samenext;
    }
/*     if(gpr_view != ON){ */
/*       if(retstat != EXIT_SUCCESS){ */
/* 	break; */
/*       } */
/*     } */

    if(retstat >= (win_w + 100)){
      break;
    }

    if(note_bot != NULL){
      if(cur == note_bot){
	view_note_bot = cur;
	break;
      }
    }
    cur = cur->next;
  }

 topexit:

  draw_H_line(pre_BT_x, pre_BT_y, win_w, pre_BT_y, BT_colors, 2);

  if( (gttm_exec == ON) && (gtop != NULL) ){
    draw_gpr5(gtop, Lbot, 1);
  }

  return EXIT_SUCCESS;
}
