#include  "4ru.h"

extern int win_w;
extern NOTE_NODE *note_bot;


/*  GPR2 Proximity
    GPR2a Slur/Rest  */
int gpr2a(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *n[4];

  double rest23;
  double rest12;
  double rest34;

  double rest_r23;
  double rest_r12;
  double rest_r34;

  double ioi23;
  double ioi12;
  double ioi34;

  double t12_bias = 0.0;
  double t34_bias = 0.0;

/*   double rest_r12_bias = 0.0; */
/*   double rest_r34_bias = 0.0; */


  cur = linetop;
  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
    t12_bias = 0.0;
    t34_bias = 0.0;

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    rest23 =
      (n[2]->on_time.beat + n[2]->on_diff.beat) - 
      (n[1]->on_time.beat + n[1]->on_diff.beat + n[1]->len.beat + n[1]->len_diff.beat);
    /*    t23 = t23 / n2.len;  */

    rest12 =
      (n[1]->on_time.beat + n[1]->on_diff.beat) -
      (n[0]->on_time.beat + n[0]->on_diff.beat + n[0]->len.beat + n[0]->len_diff.beat);
    /*  t12 = t12 / n1.len;  */

    rest34 =
      (n[3]->on_time.beat + n[3]->on_diff.beat) -
      (n[2]->on_time.beat + n[2]->on_diff.beat + n[2]->len.beat + n[2]->len_diff.beat);
    /*  t34 = t34 / n3.len;  */

    ioi23 =
      (n[2]->on_time.beat + n[2]->on_diff.beat) - 
      (n[1]->on_time.beat + n[1]->on_diff.beat);
    ioi12 =
      (n[1]->on_time.beat + n[1]->on_diff.beat) -
      (n[0]->on_time.beat + n[0]->on_diff.beat);
    ioi34 =
      (n[3]->on_time.beat + n[3]->on_diff.beat) -
      (n[2]->on_time.beat + n[2]->on_diff.beat);

    rest_r23 = rest23 / ioi23;
    rest_r12 = rest12 / ioi12;
    rest_r34 = rest34 / ioi34;

    n[1]->GPR[GPR2a] = ((rest23 - rest12) + (rest23 - rest34)) / ioi23;

    if( (rest23 >= 0.0) &&
	(((rest12 + t12_bias) < rest23) && (rest23 > (rest34 + t34_bias))) ){
      n[1]->GPR_ON_OFF[GPR2a] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR2a] = OFF;
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR2a] = n[1]->GPR[GPR2a];
      n[1]->org_node->GPR_ON_OFF[GPR2a] = n[1]->GPR_ON_OFF[GPR2a];
    }


/*     if( ((rest_r23 >= 0.0) && */
/* 	 ((rest_r12 + rest_r12_bias) < rest_r23) && (rest_r23 > (rest_r34 + rest_r34_bias))) && */
/* 	(eq((rest_r12 + rest_r12_bias), rest_r23) == 0) && (eq(rest_r23, (rest_r34 + rest_r34_bias)) == 0) ){ */
/*       n[1]->GPR_ON_OFF[GPR2a] = n[1]->org_node->GPR_ON_OFF[GPR2a] = ON; */
/*     }else{ */
/*       n[1]->GPR_ON_OFF[GPR2a] = n[1]->org_node->GPR_ON_OFF[GPR2a] = OFF; */
/*     } */

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
