/*  Time-stamp: <2005-08-08 13:40:57 >  */

#include  "NOTEfile.h"
#include  "disp_errline.h"

int note_noterest_parse(FILE *fp, char *filename,
			int line, char linebuf[], int *idx, char token[],
			NOTE_HEADER *header_info, NOTE_NODE *cur, DRUM_DEF *drum_data)
{
  double doubletmp;
  int finger;
  int i;


  get_token(linebuf, idx, token);
  if(stricmp(token, " ") == 0){
    get_token(linebuf, idx, token);
  }

  if(sscanf(token, "%lf", &doubletmp) == 1){  /*  on_diff  */
    switch(header_info->timescale){
    case  T_BEAT:
    case  NO_INFO:
      cur->on_diff.beat = doubletmp;
      break;

    case  T_REAL:
      cur->on_diff.real = doubletmp;
      break;

    case  T_DELTA:
      cur->on_diff.delta = doubletmp;
      break;

    case  T_MEAS:
      cur->on_diff.meas = doubletmp;
      break;

    default:
      br_printf(2, "%s: %d: header_info  timescale  T_BEAT, T_REAL, T_DELTA, NO_INFO ΤɤǤ⤢ޤ\n",
		__FILE__, __LINE__);
      break;
    }

    get_token(linebuf, idx, token);
    if(stricmp(token, " ") != 0){
      disp_errline(filename, line, linebuf, *idx, "on_diff ľζʸʤ");
      fclose(fp);
      exit(EXIT_FAILURE);
    }

    get_token(linebuf, idx, token);
  }


  if(is_pitchstr(token) == 0){  /*  Χ̻  */
    strcpy(cur->str[1], token);
    get_token(linebuf, idx, token);
    if(stricmp(token, " ") != 0){
      disp_errline(filename, line, linebuf, *idx, "Χ̻Ҥľζʸʤ");
      fclose(fp);
      exit(EXIT_FAILURE);
    }else{
      get_token(linebuf, idx, token);
    }
  }


  /*    */
  strcpy(cur->str[0], token);
  cur->val[0] = notename_to_notenum(token, drum_data);
  if(stricmp(token, "Rest") == 0){
    cur->ident = REST;
  }else{
    cur->ident = NOTE;
  }

  get_token(linebuf, idx, token);
  if(stricmp(token, " ") != 0){
    disp_errline(filename, line, linebuf, *idx, "ľζʸʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }
  get_token(linebuf, idx, token);

  if(check_float(token) == INTEGER){  /*   On_vel  */
    sscanf(token, "%lf", &(cur->val[1]));
    get_token(linebuf, idx, token);
    if(stricmp(token, " ") != 0){
      disp_errline(filename, line, linebuf, *idx, "On_vel ľζʸʤ");
      fclose(fp);
      exit(EXIT_FAILURE);
    }else{
      get_token(linebuf, idx, token);
    }
  }


  /*  Len  */
  sscanf(token, "%lf", &doubletmp);
  switch(header_info->timescale){
  case  T_BEAT:
  case  NO_INFO:
    cur->len.beat = doubletmp;
    break;
    
  case  T_REAL:
    cur->len.real = doubletmp;
    break;
    
  case  T_DELTA:
    cur->len.delta = doubletmp;
    break;
    
  case  T_MEAS:
    cur->len.meas = doubletmp;
    break;
    
  default:
    br_printf(2, "%s: %d: header_info  timescale  T_BEAT, T_REAL, T_DELTA, NO_INFO ΤɤǤ⤢ޤ\n",
	      __FILE__, __LINE__);
    break;
  }

  get_token(linebuf, idx, token);
  if(stricmp(token, " ") == 0){
    get_token(linebuf, idx, token);
  }


  if(check_float(token) == FLOAT){  /*   Len_diff  */
    sscanf(token, "%lf", &doubletmp);
    switch(header_info->timescale){
    case  T_BEAT:
    case  NO_INFO:
      cur->len_diff.beat = doubletmp;
      break;
      
    case  T_REAL:
      cur->len_diff.real = doubletmp;
      break;
      
    case  T_DELTA:
      cur->len_diff.delta = doubletmp;
      break;
      
    case  T_MEAS:
      cur->len_diff.meas = doubletmp;
      break;
      
    default:
      br_printf(2, "%s: %d: header_info  timescale  T_BEAT, T_REAL, T_DELTA, NO_INFO ΤɤǤ⤢ޤ\n",
		__FILE__, __LINE__);
      break;
    }

    get_token(linebuf, idx, token);
    if(stricmp(token, " ") == 0){
      get_token(linebuf, idx, token);
    }
  }


  if(check_float(token) == INTEGER){  /*   Off_vel  */
    sscanf(token, "%lf", &(cur->val[2]));

    get_token(linebuf, idx, token);
    if(stricmp(token, " ") == 0){
      get_token(linebuf, idx, token);
    }
  }


  if(tolower(*(token)) == 'f'){  /*  ֹ  */
    strcpy(cur->notations.tech.name, "fingering");
    switch(toupper(*(token + 1))){
    case  'R':
      strcpy(cur->notations.tech.place, "above");
      break;

    case  'L':
      strcpy(cur->notations.tech.place, "above");  /*  koko Ȥǽ  */
      break;

    case  '_':
      strcpy(cur->notations.tech.place, "above");  /*  koko Ȥǽ  */
      break;

    default:
      disp_errline(filename, line, linebuf, *idx, "ֹ˱󤬤ޤR, L, _ ΤɤǤʤ)");
      fclose(fp);
      exit(EXIT_FAILURE);
    }


    finger = 0;
    i = 2;
    while(1){
      if(*(token + i) == '\0'){  break; }
      finger = (finger * 10) + (*(token + i) - '0');
      i++;
    }
    cur->notations.tech.val = finger;

    get_token(linebuf, idx, token);
    if(stricmp(token, " ") == 0){
      get_token(linebuf, idx, token);
    }
  }

  if(strcmp(token, ")") != 0){
    disp_errline(filename, line, linebuf, *idx, "\')\' ʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }


  get_token(linebuf, idx, token);  /*  ')' μɤǤȴ  */


#if 0
  br_printf(-1, "%5.3f: %5.3f %s %s %d %5.3f %5.3f\n",
	    cur->on_time.meas,
	    cur->on_diff.meas,
	    cur->str[1],
	    cur->str[0],
	    (int)cur->val[1],
	    cur->len.meas,
	    cur->len_diff.meas);
#endif

  return EXIT_SUCCESS;

}
