/*  Time-stamp: <2005-04-19 18:03:48 >  */
#include  "midi_io.h"
#include  "4ru.h"
#include  "sequence.h"
#include  "signal_exit.h"


extern int view;
extern NOTE_NODE *view_note_cur;
extern double ppqbeat;
extern double alpha;
extern int scroll_play;


extern double Lbot;
extern double inter;
extern double Velbot;
extern double Veltop;
extern double draw_on_time_bias;


int sequence_play(NOTE_HEADER note_header_info, NOTE_NODE *note_top,
		  SMF_HEADER arg_smf_header_info, EL *arg_smf_top[MAX_TRK_NUM],
		  int out_port, WRITE_CTRL wctrl, PERF_CTRL pctrl, DRUM_DEF *drum_data)
{
  EL *smf_merge_top;
  EL *smf_cur;
  static EL *smf_top[MAX_TRK_NUM];
/*   SMF_HEADER smf_header_info; */
  int out_num;
  double init_counter_val;
  double now_time;
  int timescale;
  int i;
  static NOTE_NODE *part_top[PART_NUM];
  static PART_INFO  part_info[PART_NUM];
  double tempo_usec;

  static GLdouble event_colors[8][4];
  int retstat;

  
  /*  ؿؤΥݥ  */
  int (*init_counter[1])(double qbpm, double init_counter_val) = {
    init_counter_tick_up
  };

  /*  init_note_header_info(&note_header_info);  */
  /*  init_smf_header_info(&smf_header_info);  */
  init_partinfo(part_info);

/*   for(i = 0; i < PART_NUM; i++){ */
/*     NOTE_list_free(part_top[i]); */
/*   } */
  part_top[0] = note_top;
  for(i = 1; i < PART_NUM; i++){
    part_top[i] = NULL;
  }

  for(i = 0; i < MAX_TRK_NUM; i++){
    EL_list_free(smf_top[i]);
    smf_top[i] = NULL;
  }


/*   signal(SIGSEGV, signal_exit); */
  signal(SIGINT, signal_exit);


  /*  պѤ߲٥Ȥο (View ⡼ɻͭ)  */
/*   set_GLcolors_by_X11name("lemon chiffon", event_colors); */
/*   set_GLcolors_by_X11name("gold", event_colors); */
/*   set_GLcolors_by_X11name("pink", event_colors); */
  set_GLcolors_by_X11name("black", event_colors);


  if(get_midi_out_num(&out_num) == EXIT_FAILURE){
    br_printf(2, "Ѳǽ MIDI OUT ݡȤҤȤĤ⤢ޤ\n");
    return EXIT_FAILURE;
  }

  if(out_port == -2){
    br_printf(5, "\nMIDI ϥݡȤǤ\n");
    br_printf(6, "(Ϥͤϡư -outport ǻǽǤ)\n");
    out_port = select_midi_out();
  }

  if(open_midi_out(out_port) == EXIT_FAILURE){
    br_printf(2, "MIDI OUT ݡȤǤޤǤ\n");
    br_printf(2, "MIDI I/F Ĥʤʤꡤ\n");
    br_printf(2, "MIDI Ÿľꤷ\n");
    br_printf(2, "١ĩ路ƤߤƤ\n");
    br_printf(2, "ꤤޤ... \n");
    exit(EXIT_FAILURE);
  }

  if(note_header_info.timescale == NO_INFO){
    timescale = T_BEAT;
  }else{
    timescale = note_header_info.timescale;
  }

  init_counter_val = 0.0;

  smf_merge_top = smf_trk_merge(arg_smf_top, arg_smf_header_info.ntrks);

  if(smf_merge_top == NULL){
    if(note_top == NULL){
      br_printf(2, "%s: %d: դ٤󤬤ޤ(SMF  note ʤ)\n",
		__FILE__, __LINE__);
      exit(0);
    }
  }

/*   note2smf(part_top, part_info, 1, &note_header_info, smf_top, &smf_header_info, wctrl, pctrl); */

  note2smf(part_top, part_info, 1, &note_header_info, smf_top, &arg_smf_header_info, wctrl, pctrl, drum_data);

#if 0
  smf_cur = smf_top[0];
  while(1){
    if(smf_cur == NULL){
      break;
    }
    br_printf(-1, "%f: %02X\n", smf_cur->timestamp, smf_cur->stat);
    smf_cur = smf_cur->next;
  }
  exit(0);
#endif


  if(init_counter[0](DEFAULT_QBPM, init_counter_val) == EXIT_FAILURE){
    exit(0);
  }

  start_counter();

  /*
  set_tempo(header_info);
  */

  br_printf(5, "Playing... \n");

  switch(pctrl.displevel){
/*   case 0: */
/*     br_printf(-1, "Not implemented, yet.\n"); */
/*     return EXIT_SUCCESS; */
/*     break; */

  case 0:
  case 1:
  case 2:
    if(pctrl.displevel > 0){
      if(strcmp(note_header_info.title, "") != 0){
	printf("Title: %s\n", note_header_info.title);
      }
    }
    smf_cur = smf_top[0];
    while(smf_cur != NULL){
      now_time = get_counter();
/*        printf("%f: %f\n", now_time, smf_cur->timestamp);  */

      if(now_time >= smf_cur->timestamp){
	switch(smf_cur->ident){
	case  NOTE:
	  midi_out(0, smf_cur->stat, smf_cur->val1, smf_cur->val2, NULL);
	  if(pctrl.displevel >= 2){ 
	    if(view == ON){
	      if(smf_cur->note_node != NULL){
		retstat = draw_event(smf_cur->note_node, Lbot, inter, Velbot, Veltop, ppqbeat, alpha, draw_on_time_bias, event_colors,
				     drum_data);
		glutSwapBuffers();
		/* 	      glFlush(); */
	      }
	    }
	  }
	  break;


	case  DAMPER:
	case  SOSTENUTO:
	case  SOFT:
	  midi_out(0, smf_cur->stat, smf_cur->val1, smf_cur->val2, NULL);
	  break;

	case  BEATTIME:
	case  BPM:
	  tempo_usec = (smf_cur->data[0]) * 256 * 256 + (smf_cur->data[1] * 256) + smf_cur->data[2];
	  set_tempo_usec(tempo_usec);
	  break;

	case  REST:
	case  BEAT:
	case  EOT:
	case  TEXTSTR:
	  /*  ⤷ʤ  */
	  break;

	case  O_TEXTSTR:
	  midi_out(0, smf_cur->stat, smf_cur->val1, smf_cur->val2, smf_cur->data);
	  break;


	default:
	  br_printf(2, "%s: %d: %f [%02d] %02X %02X %02X: Τ MIDI å󥹥ޥɤǤ\n",
		    __FILE__, __LINE__,
		    smf_cur->timestamp_for_disp, smf_cur->ident, smf_cur->stat, smf_cur->val1, smf_cur->val2);
	  midi_exit(0);
	  exit(0);
	  break;
	}

	if(pctrl.displevel >= 1){
	  printf("%10.3f%s\n",
		 smf_cur->timestamp, smf_cur->disp_str);
	}
	if(pctrl.displevel >= 2){
	  if( (view == ON) && (scroll_play == ON) ){
	    if(smf_cur->note_node != NULL){
	      view_note_cur = smf_cur->note_node;
	      draw_all(note_header_info, view_note_cur, drum_data);
	      /* 	    re_draw(); */
	    }
	  }
	}
	smf_cur = smf_cur->next;
      }
    }

    break;

  default:
    printf("-displevel %d ϡ¸ߤޤ\n", pctrl.displevel);
    break;
  }

      /*
	塼Ͽ
	ΡȥդϿ
	߼¹
	init ¾ C maga ɤࡥ
	gettickʤ
	cur list Υ
      */

  sleep(1);
  
  /*  MIDILIST_free(midi_top);  */
  
  close_counter();
  close_midi_out(out_port);
  
  signal(SIGINT, NULL);
  

  return EXIT_SUCCESS;

}
