#include  "SMFrw.h"
#include  <limits.h>


/*------ $BFbIt4X?t%W%m%H%?%$%W@k8@(B------*/
static int get_min_node(EL *cur[MAX_TRK_NUM], int ntrks);
/*-------------------------------------*/


EL *smf_trk_merge(EL *top[MAX_TRK_NUM], int ntrks)
{
  EL *cur[MAX_TRK_NUM];
  EL *merge_top;
  EL *merge_cur;
  EL *save_pre;
  int i;


  if(ntrks < 0){
    return (EL *)NULL;
  }

  for(i = 0; i < MAX_TRK_NUM; i++){
    cur[i] = top[i];
  }

  merge_top = EL_alloc();
  merge_cur = merge_top;

  while(1){
    i = get_min_node(cur, ntrks);
    if(i == -1){  break; }
    save_pre = merge_cur->pre;
    *merge_cur = *cur[i];
    merge_cur->pre = save_pre;
    merge_cur->next = EL_alloc();
    merge_cur->next->pre = merge_cur;
    merge_cur = merge_cur->next;
    cur[i] = cur[i]->next;
  }

  if(merge_cur->pre != NULL){
    merge_cur = merge_cur->pre;
    free(merge_cur->next);
  }
  merge_cur->next = NULL;


#if DEBUG
  merge_cur = merge_top;
  while(merge_cur->next != NULL){
    printf("%f\n", merge_cur->abs_time);
    if(merge_cur->abs_time > merge_cur->next->abs_time){
      printf(">\n");
      exit(-1);
    }
    merge_cur = merge_cur->next;
  }
  printf("merge Ok\n");
#endif

  return merge_top;
}


static int get_min_node(EL *cur[MAX_TRK_NUM], int ntrks)
{
  int i;
  double min;
  int min_i;


  min = (double)INT_MAX;
  min_i = -1;
  for(i = 0; i < ntrks; i++){
    if(cur[i] == NULL){  continue; }
    if(min > cur[i]->abs_time){
      min = cur[i]->abs_time;
      min_i = i;
    }
  }


  return min_i;
}
