/*  Time-stamp: <2005-05-08 21:24:26 noike>  */
#ifndef XML2NOTE_H
#define XML2NOTE_H

#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <libxml/parser.h>
#include  <libxml/debugXML.h>
#ifdef ICONV
#include  <iconv.h>
#include  "iconv_if.h"
#endif
#include  "NOTEfile.h"
#include  "disp_ctr.h"
#include  "gcd.h"
#include  "lcm.h"
#include  "eq.h"
#include  "koko.h"
#include  "disp_err.h"


#define  VER "0.20"

#define  DEFAULT_VEL  64  /*  $B%G%U%)%k%H$GM?$($i$l$k%t%'%m%7%F%#CM(B  */

#ifndef  DEFAULT_BEAT
#define  DEFAULT_BEAT 4.0  /* $B%G%U%)%k%H$NGo;RJ,Jl(B  */
#endif


#define  STR_NUM  512
#ifndef STR_LEN
#define  STR_LEN  256
#endif
#define  PART_NUM  32
#define  INST_NUM  8

#define  OPT_NUM 64

/*------
$B9=B$BNDj5A(B
------*/
/*
  part $B$NCf$N3F@{N'$N>pJs3JG<MQ(B
  (C $B%W%j%W%m%;%C%5Cf$G$O!$A0J};2>H$,$G$-$J$$$N$G@h$K=q$$$F$"$k(B)
*/
typedef struct _score_inst{
  char id[STR_LEN];
  char instname[STR_LEN];
}SCORE_INST;


/*
  $B3F%Q!<%H$N>pJs3JG<MQ(B
  ($B$R$H$D$N%Q!<%H$KJ#?t$N@{N'$,4^$^$l$F$7$^$&$3$H$KCm0U!*(B)
 */
typedef struct _partinfo{
  char id[STR_LEN];
  char partname[STR_LEN];
  SCORE_INST inst[INST_NUM];
  int midi_ch;  /*  1 - 16  */
  int midi_prg; /*  1 - 128  */
}PART_INFO;


typedef struct _z_bias{
  double on_time;
  double xml_on_time;
  double org_xml_on_time;
}Z_BIAS;


/*  $B2;2A$KBP$9$k(B duration $B$NHfN((B  */
/*  $B2;2A$HF1$8$J$i(B 1.0  */
typedef struct _arti_dur{
  double slur[4];
  double staccato;
}ARTI_DUR;

/*------
$B4X?t%W%m%H%?%$%W@k8@(B
------*/
void title(void);

int xml_read(char *filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int *part_num,
	     xmlDoc **xml_top, NOTE_HEADER *note_header_info, char prog_name[STR_LEN],
	     int *re_divi, int default_vel[PART_NUM], ARTI_DUR *arti_dur, DRUM_DEF *drum_data);

void xml_close(xmlDocPtr doc);

xmlNode *ident_analyze(xmlNode *cur,
		       char composer[STR_LEN],
		       char generator[STR_LEN],
		       char encode_date[STR_LEN],
		       char rights[STR_LEN]);

xmlNode * part_list_analyze(xmlNode *cur, PART_INFO  partinfo[PART_NUM],
			    int *part_num, int inst_num[PART_NUM]);

xmlNode *part_analyze(xmlNode *cur, int part_idx, NOTE_NODE *part_top[PART_NUM], double now_divi[PART_NUM],
		      int default_vel[PART_NUM], ARTI_DUR *arti_dur, int *m_line_base, DRUM_DEF *drum_data);

xmlNode *xmlnote_analyze(xmlNode *cur, NOTE_NODE **part_cur, int divisions,
			 double *now_time, double *pre_duration, int default_vel[PART_NUM], double bar_haku,
			 int beat_bunbo, ARTI_DUR *arti_dur, int m_line_base, int *m_line, int part_idx, DRUM_DEF *drum_data);

int re_division(NOTE_NODE *part_top[PART_NUM], int part_num, xmlDoc *xml_doc_top, int re_divi);

/*  abstime $B=g$K%=!<%H$9$k(B($BI,$:<BAu$9$k$3$H(B)  */
int part_sort(NOTE_NODE *part_top[PART_NUM], int part_num);

int type2dur(xmlChar *type, int division, double bar_haku);

NOTE_NODE *part_merge(NOTE_NODE *part_top[PART_NUM], int part_num);

int tie_cat(NOTE_NODE *part_top[PART_NUM], int part_num);

int grace(NOTE_NODE **part_cur,
	  int divi,  /*  XML $B$N(B divisions  */
	  double *type_duration,  /*
				    <type>quater</type> $B$+$i;;=P$7$?(B duration
				    $B$3$l$,(B xml_len, len $B$K$J$k(B  */
	  double *dur_duration,   /*
				    <duration>??</duration>$B$+$i;;=P$7$?(B duration
				    $B$3$l$H(B type_duration $B$+$i(B xml_len_diff, len_diff
				    $B$,;;=P$5$l$k(B */
	  double *pre_duration,    /*
				    $B$3$l$,(B xml_step $B$K$J$k(B($B%[%s%H!)(B)  */
	  double *now_time
	  );

int re_4R(NOTE_NODE *part_top[PART_NUM], int part_num, int re_divi);

xmlNode *direction_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions, double *now_time,
			   double bar_haku, int voice);
xmlNode *notations_analyze(xmlNode *cur, NOTE_NODE **part_cur);

xmlNode *sound_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions, double now_time);

int velocity_apply(NOTE_NODE *part_top[PART_NUM], int part_num, int default_vel[PART_NUM]);

void init_partinfo(PART_INFO partinfo[PART_NUM]);

void add_attention(void);

/* ------ for debug ---------------------------------------- */
void print_element_names(xmlNode * a_node);

int chk_prop(xmlNode *cur);
/* --------------------------------------------------------- */

#endif
